#!/bin/sh

if [ $# -ne 1 ] ; then
	echo "Usage: $0 <version>" >&2
	exit 1
fi

case "$1" in
	v*)
		version="`echo $1 | cut -c 2-`"
		tag="$1"
		;;
	*)
		version="$1"
		tag="v$1"
		;;
esac

echo "version = '$version'"
echo "ok?"
read n

hg tag -f -e $tag
hg sign --no-commit $tag
hg amend
